/* jshint ignore:start */

/* jshint ignore:end */

define('dummy/app', ['exports', 'ember', 'ember/resolver', 'ember/load-initializers', 'dummy/config/environment'], function (exports, Ember, Resolver, loadInitializers, config) {

  'use strict';

  Ember['default'].MODEL_FACTORY_INJECTIONS = true;

  var App = Ember['default'].Application.extend({
    modulePrefix: config['default'].modulePrefix,
    podModulePrefix: config['default'].podModulePrefix,
    Resolver: Resolver['default']
  });

  loadInitializers['default'](App, config['default'].modulePrefix);

  exports['default'] = App;

});
define('dummy/components/storage-demo', ['exports', 'ember'], function (exports, Ember) {

  'use strict';

  exports['default'] = Ember['default'].Component.extend({
    trackMouse: (function () {
      var _this = this;

      window.onmousemove = function (e) {
        _this.x = e.x + 1;
        _this.y = e.y + 1;

        if (!window.requestAnimationFrame) {
          Ember['default'].run.throttle(_this, _this.updateLocation, 100);
        }
      };

      if (window.requestAnimationFrame) {
        this.updateLocation();
      }
    }).on("init"),
    updateLocation: function updateLocation() {
      if (this.oldX !== this.x || this.oldY !== this.y) {
        this.storage.set("mouseX", this.x);
        this.storage.set("mouseY", this.y);
        this.oldX = this.x;
        this.oldY = this.y;
      }

      if (window.requestAnimationFrame) {
        window.requestAnimationFrame(this.updateLocation.bind(this));
      }
    } });

});
define('dummy/initializers/app-version', ['exports', 'dummy/config/environment', 'ember'], function (exports, config, Ember) {

  'use strict';

  var classify = Ember['default'].String.classify;

  exports['default'] = {
    name: "App Version",
    initialize: function initialize(container, application) {
      var appName = classify(application.toString());
      Ember['default'].libraries.register(appName, config['default'].APP.version);
    }
  };

});
define('dummy/initializers/export-application-global', ['exports', 'ember', 'dummy/config/environment'], function (exports, Ember, config) {

  'use strict';

  exports.initialize = initialize;

  function initialize(container, application) {
    var classifiedName = Ember['default'].String.classify(config['default'].modulePrefix);

    if (config['default'].exportApplicationGlobal && !window[classifiedName]) {
      window[classifiedName] = application;
    }
  }

  ;

  exports['default'] = {
    name: "export-application-global",

    initialize: initialize
  };

});
define('dummy/initializers/storage-service', ['exports'], function (exports) {

  'use strict';

  exports.initialize = initialize;

  function initialize(container, application) {
    application.inject("route", "storage", "service:storage");
    application.inject("component", "storage", "service:storage");
  }

  exports['default'] = {
    name: "storage-service",
    initialize: initialize
  };

});
define('dummy/router', ['exports', 'ember', 'dummy/config/environment'], function (exports, Ember, config) {

  'use strict';

  var Router = Ember['default'].Router.extend({
    location: config['default'].locationType
  });

  Router.map(function () {});

  exports['default'] = Router;

});
define('dummy/services/storage', ['exports', 'ember'], function (exports, Ember) {

  'use strict';

  var storage = {
    local: window.localStorage,
    session: window.sessionStorage };

  exports['default'] = Ember['default'].Object.extend({
    prefix: "es",
    type: "local",

    _prefix: function _prefix(key) {
      return this.get("prefix") + "__" + key;
    },
    setUpEventListener: (function () {
      var self = this,
          regexp = new RegExp("^(" + this.get("prefix") + "__)");
      this._notify = function (evnt) {
        self.notifyPropertyChange(evnt.key.replace(regexp, ""));
      };
      window.addEventListener("storage", this._notify, false);
    }).on("init"),
    willDestroy: function willDestroy() {
      this._super();
      window.removeEventListener("storage", this._notify, false);
    },
    unknownProperty: function unknownProperty(k) {
      var key = this._prefix(k),
          type = this.get("type");
      // if we don't use JSON.parse here then observing a boolean doesn't work
      return storage[type][key] && JSON.parse(storage[type][key]);
    },
    setUnknownProperty: function setUnknownProperty(k, value) {
      var key = this._prefix(k),
          type = this.get("type");

      if (Ember['default'].isNone(value)) {
        delete storage[type][key];
      } else {
        storage[type][key] = JSON.stringify(value);
      }
      this.notifyPropertyChange(k);
      return value;
    },
    clear: function clear(keyPrefix) {
      this.beginPropertyChanges();
      var self = this,
          prefix = keyPrefix || this.get("prefix"),
          regexp = new RegExp("^(" + prefix + "__)"),
          type = this.get("type");

      var toDelete = [];
      for (var i = 0; i < storage[type].length; i++) {
        var key = storage[type].key(i);
        // don't nuke *everything* in localStorage... just keys that match our pattern
        if (key.match(regexp)) {
          toDelete.push(key);
        }
      }
      toDelete.forEach(function (key) {
        delete storage[type][key];
        key = key.replace(regexp, "");
        self.set(key);
      });
      this.endPropertyChanges();
    }
  });

});
define('dummy/templates/application', ['exports'], function (exports) {

  'use strict';

  exports['default'] = Ember.HTMLBars.template((function() {
    return {
      isHTMLBars: true,
      blockParams: 0,
      cachedFragment: null,
      hasRendered: false,
      build: function build(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createElement("h2");
        dom.setAttribute(el1,"id","title");
        var el2 = dom.createTextNode("Welcome to Ember.js");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      render: function render(context, env, contextualElement) {
        var dom = env.dom;
        var hooks = env.hooks, content = hooks.content;
        dom.detectNamespace(contextualElement);
        var fragment;
        if (env.useFragmentCache && dom.canClone) {
          if (this.cachedFragment === null) {
            fragment = this.build(dom);
            if (this.hasRendered) {
              this.cachedFragment = fragment;
            } else {
              this.hasRendered = true;
            }
          }
          if (this.cachedFragment) {
            fragment = dom.cloneNode(this.cachedFragment, true);
          }
        } else {
          fragment = this.build(dom);
        }
        var morph0 = dom.createMorphAt(fragment,1,2,contextualElement);
        content(env, morph0, context, "outlet");
        return fragment;
      }
    };
  }()));

});
define('dummy/templates/components/storage-demo', ['exports'], function (exports) {

  'use strict';

  exports['default'] = Ember.HTMLBars.template((function() {
    return {
      isHTMLBars: true,
      blockParams: 0,
      cachedFragment: null,
      hasRendered: false,
      build: function build(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("p");
        var el2 = dom.createTextNode("\n  This form remembers everything you type and syncs it between tabs:\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("form");
        var el2 = dom.createTextNode("\n  ");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("div");
        var el3 = dom.createTextNode("\n    ");
        dom.appendChild(el2, el3);
        var el3 = dom.createElement("label");
        var el4 = dom.createTextNode("Name:");
        dom.appendChild(el3, el4);
        dom.appendChild(el2, el3);
        var el3 = dom.createTextNode("\n    ");
        dom.appendChild(el2, el3);
        var el3 = dom.createTextNode("\n  ");
        dom.appendChild(el2, el3);
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n\n  ");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("div");
        var el3 = dom.createTextNode("\n    ");
        dom.appendChild(el2, el3);
        var el3 = dom.createElement("label");
        var el4 = dom.createTextNode("Email:");
        dom.appendChild(el3, el4);
        dom.appendChild(el2, el3);
        var el3 = dom.createTextNode("\n    ");
        dom.appendChild(el2, el3);
        var el3 = dom.createTextNode("\n  ");
        dom.appendChild(el2, el3);
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n\n  ");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("div");
        var el3 = dom.createTextNode("\n    ");
        dom.appendChild(el2, el3);
        var el3 = dom.createElement("label");
        var el4 = dom.createTextNode("Message:");
        dom.appendChild(el3, el4);
        dom.appendChild(el2, el3);
        var el3 = dom.createTextNode("\n    ");
        dom.appendChild(el2, el3);
        var el3 = dom.createTextNode("\n  ");
        dom.appendChild(el2, el3);
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("div");
        dom.setAttribute(el1,"id","spot");
        var el2 = dom.createTextNode("\n  ");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("div");
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      render: function render(context, env, contextualElement) {
        var dom = env.dom;
        var hooks = env.hooks, get = hooks.get, inline = hooks.inline, concat = hooks.concat, attribute = hooks.attribute;
        dom.detectNamespace(contextualElement);
        var fragment;
        if (env.useFragmentCache && dom.canClone) {
          if (this.cachedFragment === null) {
            fragment = this.build(dom);
            if (this.hasRendered) {
              this.cachedFragment = fragment;
            } else {
              this.hasRendered = true;
            }
          }
          if (this.cachedFragment) {
            fragment = dom.cloneNode(this.cachedFragment, true);
          }
        } else {
          fragment = this.build(dom);
        }
        var element0 = dom.childAt(fragment, [3]);
        var element1 = dom.childAt(fragment, [5]);
        var morph0 = dom.createMorphAt(dom.childAt(element0, [1]),2,3);
        var morph1 = dom.createMorphAt(dom.childAt(element0, [3]),2,3);
        var morph2 = dom.createMorphAt(dom.childAt(element0, [5]),2,3);
        var attrMorph0 = dom.createAttrMorph(element1, 'style');
        inline(env, morph0, context, "input", [], {"value": get(env, context, "storage.name")});
        inline(env, morph1, context, "input", [], {"value": get(env, context, "storage.email")});
        inline(env, morph2, context, "textarea", [], {"value": get(env, context, "storage.message")});
        attribute(env, attrMorph0, element1, "style", concat(env, ["left:", get(env, context, "storage.mouseX"), "px; top:", get(env, context, "storage.mouseY"), "px;"]));
        return fragment;
      }
    };
  }()));

});
define('dummy/templates/index', ['exports'], function (exports) {

  'use strict';

  exports['default'] = Ember.HTMLBars.template((function() {
    return {
      isHTMLBars: true,
      blockParams: 0,
      cachedFragment: null,
      hasRendered: false,
      build: function build(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createTextNode("\nThis is a localStorage demo. Open several tabs to this page, move your mouse\naround, and fill out the form.\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createElement("p");
        var el2 = dom.createTextNode("\n  ");
        dom.appendChild(el1, el2);
        var el2 = dom.createElement("a");
        dom.setAttribute(el2,"href","http://github.com/jerel/ember-storage");
        var el3 = dom.createTextNode("Download the code");
        dom.appendChild(el2, el3);
        dom.appendChild(el1, el2);
        var el2 = dom.createTextNode("\n");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      render: function render(context, env, contextualElement) {
        var dom = env.dom;
        var hooks = env.hooks, content = hooks.content;
        dom.detectNamespace(contextualElement);
        var fragment;
        if (env.useFragmentCache && dom.canClone) {
          if (this.cachedFragment === null) {
            fragment = this.build(dom);
            if (this.hasRendered) {
              this.cachedFragment = fragment;
            } else {
              this.hasRendered = true;
            }
          }
          if (this.cachedFragment) {
            fragment = dom.cloneNode(this.cachedFragment, true);
          }
        } else {
          fragment = this.build(dom);
        }
        var morph0 = dom.createMorphAt(fragment,0,1,contextualElement);
        content(env, morph0, context, "storage-demo");
        return fragment;
      }
    };
  }()));

});
define('dummy/tests/app.jshint', function () {

  'use strict';

  module('JSHint - .');
  test('app.js should pass jshint', function() { 
    ok(true, 'app.js should pass jshint.'); 
  });

});
define('dummy/tests/components/storage-demo.jshint', function () {

  'use strict';

  module('JSHint - components');
  test('components/storage-demo.js should pass jshint', function() { 
    ok(true, 'components/storage-demo.js should pass jshint.'); 
  });

});
define('dummy/tests/helpers/resolver', ['exports', 'ember/resolver', 'dummy/config/environment'], function (exports, Resolver, config) {

  'use strict';

  var resolver = Resolver['default'].create();

  resolver.namespace = {
    modulePrefix: config['default'].modulePrefix,
    podModulePrefix: config['default'].podModulePrefix
  };

  exports['default'] = resolver;

});
define('dummy/tests/helpers/resolver.jshint', function () {

  'use strict';

  module('JSHint - helpers');
  test('helpers/resolver.js should pass jshint', function() { 
    ok(true, 'helpers/resolver.js should pass jshint.'); 
  });

});
define('dummy/tests/helpers/start-app', ['exports', 'ember', 'dummy/app', 'dummy/router', 'dummy/config/environment'], function (exports, Ember, Application, Router, config) {

  'use strict';



  exports['default'] = startApp;
  function startApp(attrs) {
    var application;

    var attributes = Ember['default'].merge({}, config['default'].APP);
    attributes = Ember['default'].merge(attributes, attrs); // use defaults, but you can override;

    Ember['default'].run(function () {
      application = Application['default'].create(attributes);
      application.setupForTesting();
      application.injectTestHelpers();
    });

    return application;
  }

});
define('dummy/tests/helpers/start-app.jshint', function () {

  'use strict';

  module('JSHint - helpers');
  test('helpers/start-app.js should pass jshint', function() { 
    ok(true, 'helpers/start-app.js should pass jshint.'); 
  });

});
define('dummy/tests/router.jshint', function () {

  'use strict';

  module('JSHint - .');
  test('router.js should pass jshint', function() { 
    ok(true, 'router.js should pass jshint.'); 
  });

});
define('dummy/tests/test-helper', ['dummy/tests/helpers/resolver', 'ember-qunit'], function (resolver, ember_qunit) {

	'use strict';

	ember_qunit.setResolver(resolver['default']);

});
define('dummy/tests/test-helper.jshint', function () {

  'use strict';

  module('JSHint - .');
  test('test-helper.js should pass jshint', function() { 
    ok(true, 'test-helper.js should pass jshint.'); 
  });

});
define('dummy/tests/unit/services/storage-test', ['ember-qunit'], function (ember_qunit) {

  'use strict';

  ember_qunit.moduleFor("service:storage", {
    // Specify the other units that are required for this test.
    // needs: ['service:foo']
    setup: function setup() {
      this.subject().set("prefix", "test-temp");
      this.subject().set("type", "session");
    } });

  // Replace this with your real tests.
  ember_qunit.test("prefix exists and can be set", function (assert) {
    var service = this.subject();
    assert.equal(service.get("prefix"), "test-temp");
    service.set("prefix", "test");
    assert.equal(service.get("prefix"), "test");
  });

  ember_qunit.test("set prefix is applied to key", function (assert) {
    var service = this.subject();
    assert.equal(service._prefix("my-key"), "test-temp__my-key");
  });

  ember_qunit.test("integers can be set", function (assert) {
    var service = this.subject();
    service.set("age", 23);
    assert.equal(window.sessionStorage["test-temp__age"], 23);
  });

  ember_qunit.test("strings can be set", function (assert) {
    var service = this.subject();
    service.set("name", "forrest");
    assert.equal(window.sessionStorage["test-temp__name"], JSON.stringify("forrest"));
    assert.equal(service.get("name"), "forrest");
  });

  ember_qunit.test("objects can be set", function (assert) {
    var service = this.subject(),
        user = {
      name: "forrest",
      weight: 170 };
    service.set("user", user);
    assert.equal(window.sessionStorage["test-temp__user"], JSON.stringify(user));
    assert.equal(JSON.stringify(service.get("user")), JSON.stringify(user));
  });

  ember_qunit.test("arrays can be set", function (assert) {
    var service = this.subject(),
        friends = ["jenny"];
    service.set("friends", friends);
    assert.equal(window.sessionStorage["test-temp__friends"], JSON.stringify(friends));
    assert.equal(JSON.stringify(service.get("friends")), JSON.stringify(friends));
  });

  ember_qunit.test("items set by this service can be cleared", function (assert) {
    assert.expect(1);
    var service = this.subject(),
        length = window.sessionStorage.length;

    service.clear();
    assert.ok(length > window.sessionStorage.length);
    for (var i = 0; i < window.sessionStorage.length; i++) {
      var key = window.sessionStorage.key(i);
      if (key && key.match(/^test-temp__.*?/)) {
        assert.ok(false, "Undeleted item in storage");
      }
    }
  });

});
define('dummy/tests/unit/services/storage-test.jshint', function () {

  'use strict';

  module('JSHint - unit/services');
  test('unit/services/storage-test.js should pass jshint', function() { 
    ok(true, 'unit/services/storage-test.js should pass jshint.'); 
  });

});
/* jshint ignore:start */

/* jshint ignore:end */

/* jshint ignore:start */

define('dummy/config/environment', ['ember'], function(Ember) {
  var prefix = 'dummy';
/* jshint ignore:start */

try {
  var metaName = prefix + '/config/environment';
  var rawConfig = Ember['default'].$('meta[name="' + metaName + '"]').attr('content');
  var config = JSON.parse(unescape(rawConfig));

  return { 'default': config };
}
catch(err) {
  throw new Error('Could not read config from meta tag with name "' + metaName + '".');
}

/* jshint ignore:end */

});

if (runningTests) {
  require("dummy/tests/test-helper");
} else {
  require("dummy/app")["default"].create({"name":"ember-storage","version":"1.0.0.6f195fea"});
}

/* jshint ignore:end */
//# sourceMappingURL=dummy.map